/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package kontroler;

import domen.Korisnik;
import javax.enterprise.context.ApplicationScoped;
import javax.inject.Named;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.Persistence;

/**
 *
 * @author student
 */
@Named("Kontroler")
@ApplicationScoped
public class Kontroler {
    
    private EntityManagerFactory emf = Persistence.createEntityManagerFactory("JSFAppKorisnikPU");

    
    
    public Korisnik prijaviKorisnika(Korisnik k) throws Exception{
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();

        try {

            Korisnik korisnikDB = (Korisnik) em.createQuery("Select k from Korisnik k "
                    + "where k.korisnickoime=:korisnickoIme")
                    .setParameter("korisnickoIme", k.getKorisnickoime()).getSingleResult();
            em.getTransaction().commit();
            em.close();

            if (korisnikDB.getKorisnickasifra().equals(k.getKorisnickasifra())) {
                return korisnikDB;
            } else {
                throw new Exception("Ne postoji korisnik sa tim privilegijama!");
            }

        } catch (NoResultException ex) {
            throw new Exception("Ne postoji korisnik sa tim privilegijama!");
        } catch (NonUniqueResultException nure) {
            throw new Exception("Ne postoji korisnik sa tim privilegijama!");
        }
        
    }
    
    
    public Korisnik sacuvajKorisnika(Korisnik k){
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        
        Korisnik korisnikDB = em.find(Korisnik.class, k.getKorisnickoime());
        
        korisnikDB = em.merge(k);
        
        //em.flush();
        
        em.getTransaction().commit();
        
        
        em.close();
        return korisnikDB;
    }
    
    
}
